


# Guidelines for Contributing to revIgniter

## How Can I Contribute?


### Code Contribution

Make your contributions to revIgniter in the form of pull requests on the [revIgniter repository](https://github.com/revig/revigniter/) on GitHub.  
revIgniter adheres to the [git-flow](http://nvie.com/posts/a-successful-git-branching-model/) process. This workflow requires that all commits need to be made to "develop" and all pull requests need to be sent to the "develop" branch.  
Please respect the coding conventions used throughout the project (indentation, comments, etc.) and any other requirements. In case your contribution requires the documentation to be extended please read the [documentation guidelines](http://revigniter.com/userGuide/docStyle/index.html) in the User Guide and add to the User Guide whatever is needed.  
Before generating a significant pull request (new features, refactoring code etc.) please ask. Otherwise you risk spending a lot of time on something the project's developers might be reluctant to merge into the project.  
Please note: By sending a pull request to the [revIgniter repository](https://github.com/revig/revigniter/) on GitHub, you certify to a "Developer's Certificate of Origin" as in [DCO.txt](DCO.txt) located in the root of this repository. This requires you to sign your work like `git commit --signoff`.

**Git Commit Messages**

- Use the present tense ("Add feature" not "Added feature").
- Limit the first line to 72 characters or less.
- Sign your work.

**Pull Requests**

- Please fill out the [required template](PULL_REQUEST_TEMPLATE.md).


### Reporting Bugs

Please fill out the [required template](ISSUE_TEMPLATE.md). Include as many details as possible. Describe the issue and include additional details to help reproduce your findings:

- Use a descriptive title.
- Describe the steps which reproduce the issue.
- Provide snippets as Markdown code blocks.
- Describe what you observed after following the steps and explain what exactly the problem is.
- Explain which result you expected instead.
- Which version of revIgniter are you using?
- Which version of LiveCode server are you using?
